module GmapsTz
  class ResponseParser
    def initialize(uri, response)
      @uri
      @response = response
    end

    def execute
      json = parse_json

      if json["status"] == "OK"
        json
      else
        raise Error.from_json(@uri, json)
      end
    end

    private

    def parse_json
      begin
        JSON.parse(@response.body)
      rescue JSON::ParserError
        raise InvalidResponseBodyError.new(@uri, @response)
      end
    end

  end
end